#ifndef NDEBUG
#  include <iostream>
#endif
#include <cassert>
#include <fstream>
#include <algorithm>
#include <vector>


#define arch pair<int,int>

using namespace std;

int N,M,totalw,parente[10000],sol[10000][2],nval=0;

ifstream fin("input.txt");
ofstream fout("output.txt");

vector < pair <int, arch> > GraphT , TreeR;

void readFromFile(){
     for (int i=0;i<M;i++){
         int src,edge,weight;
     	 fin>>src>>edge>>weight;
         GraphT.push_back(pair<int , arch>(weight,arch(src,edge)));
	 }
}


int find(int *parente, int n )
{
    if(n!=parente[n])
    {
        parente[n] = find(parente,parente[n]);
    }
    return parente[n];
}

void writeToFile(){
     fout<<totalw<<endl;
     for (int i=0;i<nval;i++){
         fout<<sol[i][0]<<' '<<sol[i][1]<<endl;
	 }
}

void compute()
{
    sort(GraphT.begin(),GraphT.end());

    for(int i=0; i<M; i++)
    {
        int x = find(parente,GraphT[i].second.first);
        int y = find(parente,GraphT[i].second.second);

        if(x!=y)
        {
            parente[x] = parente[y];
            sol[nval][0]=GraphT[i].second.first;
            sol[nval][1]=GraphT[i].second.second;
            nval++;
            totalw+=GraphT[i].first;
            TreeR.push_back(GraphT[i]);
            
        }
    }
}


int main()
{
    fin>>N>>M;

    for(int i=1; i<=N; i++)
    {
        parente[i] = i;
    }

    TreeR.clear();
    GraphT.clear();

    readFromFile();

    compute();

    writeToFile();

    return 0;
}
